/*
 * Inode structure as it appears on
 * a disk block. 64 bytes.
 */
struct dinode {
	off_t	di_size;	/* number of bytes in file */
	char	di_nlink;	/* number of links to file */
	unsigned char di_mode;	/* mode and type of file */
	char	di_avail;
	char	di_addr[NADDR * 3];	/* disk block addresses */
};

