.sect .text; .sect .rom; .sect .data; .sect .bss
.extern _bread
.sect .text
_bread:
	push	bp
	mov	bp,sp
push si
push 8(bp)
push 6(bp)
push 4(bp)
call _getblk
add sp,6
mov si,ax
testb (si),2
jne I1_1
or (si),1
mov 16(si),512
mov cx,8
mov dx,4(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
push si
call 4(bx)
push si
call _iowait
pop bx
pop bx
I1_1:
mov ax,si
jmp .sret
.extern _breada
_breada:
	push	bp
	mov	bp,sp
push si
push di
xor si,si
push 8(bp)
push 6(bp)
push 4(bp)
call _incore
add sp,6
or ax,ax
jne I2_1
push 8(bp)
push 6(bp)
push 4(bp)
call _getblk
add sp,6
mov si,ax
testb (si),2
jne I2_1
or (si),1
mov 16(si),512
mov cx,8
mov dx,4(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
push si
call 4(bx)
pop bx
I2_1:
mov dx,12(bp)
or dx,10(bp)
je I2_2
push 12(bp)
push 10(bp)
push 4(bp)
call _incore
add sp,6
or ax,ax
jne I2_2
push 12(bp)
push 10(bp)
push 4(bp)
call _getblk
add sp,6
mov di,ax
testb (di),2
je I2_3
push di
call _brelse
jmp I2_6
I2_3:
or (di),65
mov 16(di),512
mov cx,8
mov dx,4(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
push di
call 4(bx)
I2_6:
pop bx
I2_2:
or si,si
jne I2_4
push 8(bp)
push 6(bp)
push 4(bp)
call _bread
add sp,6
jmp I2_5
I2_4:
push si
call _iowait
pop bx
mov ax,si
I2_5:
jmp .dsret
.extern _bwrite
_bwrite:
	push	bp
	mov	bp,sp
	push	ax
push si
mov si,4(bp)
mov dx,(si)
mov -2(bp),dx
and (si),-168
mov 16(si),512
mov cx,8
mov dx,10(si)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
push si
call 4(bx)
pop bx
testb -2(bp),64
jne I3_1
push si
call _iowait
push si
call _brelse
pop bx
pop bx
jmp I3_2
I3_1:
testb -2(bp),128
je I3_3
or (si),32
jmp I3_2
I3_3:
testb (si),4
je I3_2
movb (_errno),5
I3_2:
jmp .sret
.extern _bdwrite
_bdwrite:
	push	bp
	mov	bp,sp
	push	ax
push si
mov si,4(bp)
mov cx,8
mov dx,10(si)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
mov dx,6(bx)
mov -2(bp),dx
mov bx,-2(bp)
test (bx),256
je I4_1
push si
call _bawrite
jmp I4_3
I4_1:
or (si),130
push si
call _brelse
I4_3:
pop bx
jmp .sret
.extern _bawrite
_bawrite:
	push	bp
	mov	bp,sp
mov bx,4(bp)
or (bx),64
! kill bx
push 4(bp)
call _bwrite
pop bx
jmp .cret
.extern _brelse
_brelse:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
push di
mov si,4(bp)
testb (si),16
je I6_1
push si
call _wakeup
pop bx
I6_1:
testb (_bfreelist),16
je I6_2
and (_bfreelist),-17
mov ax,_bfreelist
push ax
call _wakeup
pop bx
I6_2:
testb (si),4
je I6_3
mov 10(si),-1
I6_3:
call _splbio
mov -4(bp),ax
testb (si),32
je I6_4
mov di,_bfreelist+6
mov bx,(di)
mov 8(bx),si
mov dx,(di)
mov 6(si),dx
mov (di),si
mov 8(si),_bfreelist
jmp I6_5
I6_4:
mov di,_bfreelist+8
mov bx,(di)
mov 6(bx),si
mov dx,(di)
mov 8(si),dx
mov (di),si
mov 6(si),_bfreelist
I6_5:
and (si),-121
push -4(bp)
call _splx
pop bx
jmp .dsret
.extern _incore
_incore:
	push	bp
	mov	bp,sp
push si
push di
mov cx,8
mov dx,4(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
mov di,6(bx)
mov si,2(di)
jmp I7_1
I7_5:
mov dx,6(bp)
mov cx,8(bp)
cmp 12(si),dx
jne I7_3
cmp 14(si),cx
jne I7_3
mov dx,4(bp)
cmp 10(si),dx
jne I7_3
mov ax,1
jmp I7_4
I7_3:
mov si,2(si)
I7_1:
cmp si,di
jne I7_5
xor ax,ax
I7_4:
jmp .dsret
.extern _baddr
_baddr:
	push	bp
	mov	bp,sp
push 8(bp)
push 6(bp)
push 4(bp)
call _incore
add sp,6
or ax,ax
je I8_1
push 8(bp)
push 6(bp)
push 4(bp)
call _bread
add sp,6
jmp I8_2
I8_1:
xor ax,ax
I8_2:
jmp .cret
.extern _getblk
_getblk:
	push	bp
	mov	bp,sp
push si
push di
mov cx,8
mov dx,4(bp)
shr dx,cl
xorb dh,dh
cmp (_nblkdev),dx
jg I9_1
mov ax,__II0
push ax
call _panic
I9_10:
pop bx
I9_1:
call _spl0
mov cx,8
mov dx,4(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
mov di,6(bx)
or di,di
jne I9_2
mov ax,__II1
push ax
call _panic
pop bx
I9_2:
mov si,2(di)
jmp I9_3
I9_13:
mov dx,6(bp)
mov cx,8(bp)
cmp 12(si),dx
jne I9_5
cmp 14(si),cx
jne I9_5
mov dx,4(bp)
cmp 10(si),dx
jne I9_5
call _splbio
testb (si),8
je I9_6
or (si),16
mov ax,si
mov bx,21
push bx
I9_11:
push ax
call _sleep
pop bx
pop bx
jmp I9_1
I9_6:
call _spl0
push si
call _notavail
pop bx
jmp I9_12
I9_5:
mov si,2(si)
I9_3:
cmp si,di
jne I9_13
call _splbio
cmp (_bfreelist+6),_bfreelist
jne I9_8
or (_bfreelist),16
mov ax,_bfreelist
mov bx,21
push bx
jmp I9_11
I9_8:
call _spl0
mov si,(_bfreelist+6)
push si
call _notavail
pop bx
testb (si),128
je I9_9
or (si),64
push si
call _bwrite
jmp I9_10
I9_9:
mov (si),8
mov bx,4(si)
mov dx,2(si)
mov 2(bx),dx
mov bx,2(si)
mov dx,4(si)
mov 4(bx),dx
mov dx,2(di)
mov 2(si),dx
mov 4(si),di
mov bx,2(di)
mov 4(bx),si
mov 2(di),si
mov dx,4(bp)
mov 10(si),dx
mov dx,6(bp)
mov cx,8(bp)
mov 12(si),dx
mov 14(si),cx
I9_12:
mov ax,si
jmp .dsret
.extern _geteblk
_geteblk:
	push	bp
	mov	bp,sp
push si
push di
Ia_1:
call _splbio
jmp Ia_2
Ia_5:
or (_bfreelist),16
mov ax,21
push ax
mov ax,_bfreelist
push ax
call _sleep
pop bx
pop bx
Ia_2:
cmp (_bfreelist+6),_bfreelist
je Ia_5
call _spl0
mov si,(_bfreelist+6)
push si
call _notavail
pop bx
testb (si),128
je Ia_4
or (si),64
push si
call _bwrite
pop bx
jmp Ia_1
Ia_4:
mov di,_bfreelist
mov (si),8
mov bx,4(si)
mov dx,2(si)
mov 2(bx),dx
mov bx,2(si)
mov dx,4(si)
mov 4(bx),dx
mov dx,2(di)
mov 2(si),dx
mov 4(si),di
mov bx,2(di)
mov 4(bx),si
mov 2(di),si
mov 10(si),-1
mov ax,si
jmp .dsret
.extern _iowait
_iowait:
	push	bp
	mov	bp,sp
push si
mov si,4(bp)
call _splbio
jmp Ib_1
Ib_4:
mov ax,20
push ax
push si
call _sleep
pop bx
pop bx
Ib_1:
testb (si),2
je Ib_4
call _spl0
testb (si),4
je Ib_3
movb (_errno),5
Ib_3:
jmp .sret
.extern _notavail
_notavail:
	push	bp
	mov	bp,sp
	push	ax
push si
mov si,4(bp)
call _splbio
mov -2(bp),ax
mov bx,8(si)
mov dx,6(si)
mov 6(bx),dx
mov bx,6(si)
mov dx,8(si)
mov 8(bx),dx
or (si),8
push -2(bp)
call _splx
pop bx
jmp .sret
.extern _iodone
_iodone:
	push	bp
	mov	bp,sp
	push	ax
push si
mov si,4(bp)
mov dx,(si)
or dx,2
mov (si),dx
testb dl,64
je Id_1
push si
call _brelse
jmp Id_3
Id_1:
and (si),-17
push si
call _wakeup
Id_3:
pop bx
jmp .sret
.extern _clrbuf
_clrbuf:
	push	bp
	mov	bp,sp
mov bx,4(bp)
mov 18(bx),0
mov bx,4(bp)
mov ax,512
push ax
push 20(bx)
call _bzero
pop bx
pop bx
jmp .cret
.extern _bflush
_bflush:
	push	bp
	mov	bp,sp
push si
If_1:
call _splbio
mov si,(_bfreelist+6)
jmp If_2
If_6:
testb (si),128
je If_4
cmp 4(bp),-1
je If_5
mov dx,4(bp)
cmp 10(si),dx
jne If_4
If_5:
or (si),64
push si
call _notavail
push si
call _bwrite
pop bx
pop bx
jmp If_1
If_4:
mov si,6(si)
If_2:
cmp si,_bfreelist
jne If_6
call _spl0
jmp .sret
.extern _physio
_physio:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
push di
mov si,6(bp)
mov di,16
call _splbio
jmp I10_1
I10_11:
or (si),di
mov ax,21
push ax
push si
call _sleep
pop bx
pop bx
I10_1:
testb (si),8
jne I10_11
mov dx,520
or dx,10(bp)
mov (si),dx
call _spl0
mov dx,8(bp)
mov 10(si),dx
mov dx,(_curproc)
mov 22(si),dx
mov bx,(_curproc)
or 4(bx),8
! kill bx
jmp I10_3
I10_9:
and (si),-3
mov bx,(_curproc)
mov dx,72(bx)
mov 16(si),dx
mov bx,(_curproc)
mov dx,74(bx)
mov 20(si),dx
mov bx,(_curproc)
mov cx,9
mov dx,68(bx)
mov ax,70(bx)
jcxz 1f
2:
sar ax,1
rcr dx,1
loop 2b
1:
mov 12(si),dx
mov 14(si),ax
push si
call 12(bp)
mov di,16(si)
push si
call 4(bp)
pop bx
pop bx
call _splbio
jmp I10_5
I10_10:
mov ax,20
push ax
push si
call _sleep
pop bx
pop bx
I10_5:
testb (si),2
je I10_10
call _spl0
testb (si),4
je I10_7
movb (_errno),5
jmp I10_4
I10_7:
mov bx,(_curproc)
mov dx,di
add dx,74(bx)
mov 74(bx),dx
mov ax,di
cwd
mov bx,(_curproc)
add ax,68(bx)
adc dx,70(bx)
mov 68(bx),ax
mov 70(bx),dx
mov bx,(_curproc)
mov dx,72(bx)
sub dx,di
mov 72(bx),dx
I10_3:
mov bx,(_curproc)
cmp 72(bx),0
jne I10_9
I10_4:
mov bx,(_curproc)
and 4(bx),-9
! kill bx
mov bx,(_curproc)
mov dx,18(si)
mov 72(bx),dx
mov dx,(si)
and dx,-9
mov (si),dx
testb dl,16
je I10_8
and (si),-17
push si
call _wakeup
pop bx
I10_8:
jmp .dsret
.extern _minphys
_minphys:
	push	bp
	mov	bp,sp
mov bx,4(bp)
cmp 16(bx),32768
jbe I11_1
mov 16(bx),32768
I11_1:
jmp .cret
.sect .data
__II1:
.data2	25956
.data2	29814
.data2	25185
.data2	0
__II0:
.data2	27746
.data2	25707
.data2	30309
.data2	0
.sect .text
