	.sect .text
	.sect .rom
	.sect .data
	.sect .bss

	.define _errno, _etext, _edata, _end, __end

	.define .trp
	EODDZ = 19

	p_ksp = 42  ! XXX

!----------------------------------------------------------------------
	.sect .rom
_rom:
	.sect .data
_data:
!----------------------------------------------------------------------
	.sect .bss
_bss:
	.space 1024
_intstack:
	.space 4

_errno:
	.space 2

!----------------------------------------------------------------------
	.sect .text
begin:
.trp:
	xor bp, bp
	call _main
	jmp begin

!----------------------------------------------------------------------
	.define _asm_switch
_asm_switch:
	push bp
	mov bp, sp
	push si
	push di
	pushf
	push (_errno)

	mov bx, (_curproc)
	mov p_ksp(bx), sp
	mov bx, 4(bp)       ! new proc
	mov sp, p_ksp(bx)
	mov (_curproc), bx

	pop (_errno)
	popf
	pop di
	pop si
	pop bp
	ret

!----------------------------------------------------------------------
	.define .cret, .dret, .sret, .sdret, .dsret
.dsret:
	pop di
.sret:
	pop si
	leave
	ret
.sdret:
	pop si
.dret:
	pop di
.cret:
	leave
	ret

!----------------------------------------------------------------------
	.define .csa2
.csa2:
	mov dx, (bx)      ! default
	sub ax, 2(bx)     ! index - low
	cmp ax, 4(bx)     ! last
	ja 1f
	shl ax, 1
	add bx, ax
	mov bx, 6(bx)
	test bx, bx
	jz 1f
	jmp bx
1:
	jmp dx

!----------------------------------------------------------------------
	.define .csb2
.csb2:
	mov dx, (bx)      ! default
	mov cx, 2(bx)     ! count
1:
	add bx, 4
	dec cx
	jl 1f
	cmp ax, (bx)
	jne 1b
	mov bx, 2(bx)
	test bx, bx
	jz 1f
	jmp bx
1:
	jmp dx

!----------------------------------------------------------------------
