.sect .text; .sect .rom; .sect .data; .sect .bss
.extern _sleep
.sect .text
_sleep:
	push	bp
	mov	bp,sp
	sub	sp,6
push si
push di
cmp 4(bp),0
jne I1_1
mov ax,__II1
push ax
call _panic
pop bx
I1_1:
mov cx,5
mov dx,4(bp)
shr dx,cl
and dx,63
mov bx,dx
sal bx,1
lea di,_slpque(bx)
mov si,(_curproc)
call _splhigh
mov -6(bp),ax
cmp 6(bp),25
jle I1_2
call _issig
or ax,ax
je I1_2
push -6(bp)
call _splx
pop bx
mov ax,1
jmp I1_3
I1_2:
mov dx,4(bp)
mov 20(si),dx
mov dx,6(bp)
movb 7(si),dl
movb 6(si),3
mov dx,(di)
mov (si),dx
mov (di),si
call _swtch
push -6(bp)
call _splx
pop bx
xor ax,ax
cmp 20(si),0
je 1f
inc ax
1:
I1_3:
jmp .dsret
.extern _wakeup
_wakeup:
	push	bp
	mov	bp,sp
	sub	sp,6
push si
push di
mov cx,5
mov dx,4(bp)
shr dx,cl
and dx,63
mov bx,dx
sal bx,1
lea di,_slpque(bx)
call _splhigh
mov -6(bp),ax
jmp I2_1
I2_4:
mov dx,4(bp)
cmp 20(si),dx
jne I2_3
mov 20(si),0
mov dx,(si)
mov (di),dx
push si
call _setrun
pop bx
jmp I2_1
I2_3:
mov di,si
I2_1:
mov si,(di)
or si,si
jne I2_4
push -6(bp)
call _splx
pop bx
jmp .dsret
.extern _setrun
_setrun:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
push di
mov di,4(bp)
movb al,6(di)
cbw
cmp ax,1
jg I3_1
mov ax,__II2
push ax
call _panic
pop bx
I3_1:
call _splhigh
mov -4(bp),ax
cmpb 6(di),3
jne I3_2
mov cx,5
mov dx,20(di)
shr dx,cl
and dx,63
mov bx,dx
sal bx,1
lea si,_slpque(bx)
jmp I3_3
I3_7:
cmp (si),0
jne I3_5
mov ax,__II3
push ax
call _panic
pop bx
I3_5:
mov si,(si)
I3_3:
cmp (si),di
jne I3_7
mov dx,(di)
mov (si),dx
I3_2:
movb 6(di),4
mov dx,(_runq)
mov (di),dx
mov (_runq),di
push -4(bp)
call _splx
pop bx
movb al,7(di)
cbw
cmp (_curpri),ax
jle I3_6
movb (_runrun),1
I3_6:
jmp .dsret
.extern _setpri
_setpri:
	push	bp
	mov	bp,sp
push si
mov bx,4(bp)
! kill bx
mov cx,16
movb al,9(bx)
xorb ah,ah
cwd
idiv cx
mov bx,4(bp)
! kill bx
mov dx,ax
movb al,8(bx)
cbw
add ax,dx
add ax,30
mov si,ax
cmp si,127
jle I4_1
mov si,127
I4_1:
mov bx,4(bp)
! kill bx
mov dx,si
movb 7(bx),dl
cmp (_curpri),si
jle I4_2
movb (_runrun),1
I4_2:
mov ax,si
jmp .sret
.extern _qswtch
_qswtch:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
mov si,(_curproc)
call _splhigh
mov -4(bp),ax
mov dx,(_runq)
mov (si),dx
mov (_runq),si
push -4(bp)
call _splx
pop bx
call _swtch
jmp .sret
.extern _swtch
_swtch:
	push	bp
	mov	bp,sp
	sub	sp,8
push si
push di
mov -8(bp),128
mov -6(bp),0
I6_1:
call _splhigh
mov di,_runq
jmp I6_2
I6_6:
cmpb 6(si),4
jne I6_4
testb 4(si),1
je I6_4
movb al,7(si)
cbw
cmp -8(bp),ax
jle I6_4
cbw
mov -8(bp),ax
mov -6(bp),di
I6_4:
mov di,si
I6_2:
mov si,(di)
or si,si
jne I6_6
cmp -6(bp),0
jne I6_5
call _idle
jmp I6_1
I6_5:
mov bx,-6(bp)
mov si,(bx)
mov dx,(si)
mov bx,-6(bp)
mov (bx),dx
! kill bx
mov dx,-8(bp)
mov (_curpri),dx
movb (_runrun),0
call _spl0
push si
call _asm_switch
pop bx
jmp .dsret
.extern _slpque
.sect .bss
.comm _slpque,128
.extern _runq
.comm _runq,2
.extern _curpri
.comm _curpri,2
.sect .data
__II3:
.data2	25971
.data2	29300
.data2	28277
.data2	29472
.data2	28780
.data2	30065
.data2	101
__II2:
.data2	25971
.data2	29300
.data2	28277
.data2	31264
.data2	28015
.data2	98
__II1:
.data2	25978
.data2	28530
.data2	30496
.data2	26723
.data2	28257
.data2	0
.sect .text
