.sect .text; .sect .rom; .sect .data; .sect .bss
.extern _sys_fstat
.sect .text
_sys_fstat:
	push	bp
	mov	bp,sp
push si
push 4(bp)
call _getf
pop bx
mov si,ax
or si,si
je I1_1
testb (si),64
je I1_2
push 6(si)
push 4(si)
jmp I1_3
I1_2:
xor ax,ax
push ax
push ax
I1_3:
push 6(bp)
push 2(si)
call _stat
add sp,8
I1_1:
jmp .sret
.extern _sys_stat
_sys_stat:
	push	bp
	mov	bp,sp
push si
xor ax,ax
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or si,si
je I2_1
xor ax,ax
push ax
push ax
push 6(bp)
push si
call _stat
push si
call _iput
add sp,10
I2_1:
jmp .sret
.extern _stat
_stat:
	push	bp
	mov	bp,sp
	sub	sp,14
push si
mov si,4(bp)
mov bx,4(si)
mov dx,(bx)
mov -14(bp),dx
mov dx,2(si)
mov -10(bp),dx
movb cl,15(si)
movb -2(bp),cl
movb al,14(si)
cbw
mov -8(bp),ax
mov dx,16(si)
mov -12(bp),dx
mov dx,10(si)
mov cx,12(si)
sub dx,8(bp)
sbb cx,10(bp)
mov -6(bp),dx
mov -4(bp),cx
mov ax,14
push ax
push 6(bp)
lea ax,-14(bp)
push ax
call _copyout
add sp,6
or ax,ax
je I3_1
movb (_errno),14
I3_1:
jmp .sret
.extern _sys_dup2
_sys_dup2:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
push di
push 4(bp)
call _getf
pop bx
mov si,ax
or si,si
jne I4_1
I4_6:
mov ax,-1
jmp I4_2
I4_1:
mov di,6(bp)
or di,di
jns I4_3
call _ufalloc
mov di,ax
or ax,ax
jns I4_4
jmp I4_6
I4_3:
cmp di,20
jl I4_4
movb (_errno),9
jmp I4_6
I4_4:
cmp 4(bp),di
je I4_5
movb al,1(si)
cbw
inc ax
movb 1(si),al
mov bx,(_curproc)
! kill bx
mov dx,di
sal dx,1
mov -4(bp),dx
add bx,dx
push 98(bx)
call _closef
pop bx
mov bx,(_curproc)
! kill bx
add bx,-4(bp)
mov 98(bx),si
mov bx,(_curproc)
! kill bx
add bx,di
movb 78(bx),0
I4_5:
mov ax,di
I4_2:
jmp .dsret
.extern _sys_mount
_sys_mount:
	push	bp
	mov	bp,sp
	sub	sp,12
push si
push di
push 4(bp)
call _getmdev
pop bx
mov -2(bp),ax
cmpb (_errno),0
jne I5_1
xor ax,ax
push ax
push 6(bp)
call _namei
pop bx
pop bx
mov di,ax
or di,di
je I5_1
cmpb 1(di),1
jne I5_2
movb dl,15(di)
xorb dh,dh
and dx,224
cmp dx,192
jne I5_2
testb (di),4
jne I5_2
mov -10(bp),0
mov si,_mount
jmp I5_3
I5_13:
mov dx,-2(bp)
cmp (si),dx
je I5_2
cmp (si),-1
jne I5_5
cmp -10(bp),0
jne I5_5
mov -10(bp),si
I5_5:
add si,516
I5_3:
cmp si,_mount+1548
jb I5_13
mov si,-10(bp)
or si,si
je I5_2
cmp 8(bp),0
je I5_6
mov ax,1
jmp I5_7
I5_6:
mov ax,3
I5_7:
mov cx,8
mov dx,-2(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
push ax
push -2(bp)
call (bx)
pop bx
pop bx
cmpb (_errno),0
jne I5_2
xor ax,ax
push ax
mov ax,1
push ax
push -2(bp)
call _bread
add sp,6
mov -12(bp),ax
cmpb (_errno),0
je I5_8
push -12(bp)
call _brelse
pop bx
jmp I5_9
I5_8:
mov 2(si),di
mov dx,-2(bp)
mov (si),dx
add si,4
mov bx,-12(bp)
mov ax,512
push ax
push si
push 20(bx)
call _bcopy
push -12(bp)
call _brelse
add sp,8
movb 413(si),0
movb 412(si),0
cmp 8(bp),0
je I5_10
mov ax,1
jmp I5_11
I5_10:
xor ax,ax
I5_11:
movb 411(si),al
mov 414(si),1
mov 416(si),0
movb al,(di)
cbw
or ax,4
movb (di),al
push di
call _prele
jmp I5_12
I5_2:
movb (_errno),16
I5_9:
push di
call _iput
I5_12:
pop bx
I5_1:
jmp .dsret
.extern _sys_umount
_sys_umount:
	push	bp
	mov	bp,sp
	sub	sp,6
push si
push di
push 4(bp)
call _getmdev
pop bx
mov -6(bp),ax
cmpb (_errno),0
jne I6_1
mov si,_mount
jmp I6_2
I6_9:
mov dx,-6(bp)
cmp (si),dx
je I6_4
add si,516
I6_2:
cmp si,_mount+1548
jb I6_9
movb (_errno),22
jmp I6_1
I6_4:
mov di,_inode
jmp I6_5
I6_8:
cmp 4(di),si
jne I6_7
movb (_errno),16
jmp I6_1
I6_7:
add di,92
I6_5:
cmp di,_inode+5520
jb I6_8
call _update
mov cx,8
mov dx,-6(bp)
shr dx,cl
xorb dh,dh
mov cx,3
sal dx,cl
add dx,_bdevsw
mov bx,dx
xor ax,ax
push ax
push -6(bp)
call 2(bx)
pop bx
pop bx
mov (si),-1
mov di,2(si)
movb al,(di)
cbw
and ax,-5
movb (di),al
push di
call _plock
push di
call _iput
pop bx
pop bx
I6_1:
jmp .dsret
.extern _getmdev
_getmdev:
	push	bp
	mov	bp,sp
	push	ax
	push	ax
push si
xor ax,ax
push ax
push 4(bp)
call _namei
pop bx
pop bx
mov si,ax
or si,si
jne I7_1
mov ax,-1
jmp I7_2
I7_1:
movb dl,15(si)
xorb dh,dh
and dx,224
cmp dx,96
je I7_3
movb (_errno),15
I7_3:
mov dx,16(si)
mov -4(bp),dx
mov cx,8
shr dx,cl
xorb dh,dh
cmp (_nblkdev),dx
jg I7_4
movb (_errno),6
I7_4:
push si
call _iput
pop bx
mov ax,-4(bp)
I7_2:
jmp .sret
