
#include "../h/param.h"

int
	noop(),
	enosys(),
	sys_alarm(),
	sys_chdir(),
	sys_chmod(),
	sys_close(),
	sys_dup2(),
	sys_execve(),
	sys_exit(),
	sys_fork(),
	sys_fstat(),
	sys_getpid(),
	sys_getppid(),
	sys_gettimeofday(),
	sys_ioctl(),
	sys_kill(),
	sys_link(),
	sys_lseek(),
	sys_mkdir(),
	sys_mknod(),
	sys_mount(),
	sys_nice(),
	sys_open(),
	sys_pause(),
	sys_pipe(),
	sys_read(),
	sys_settimeofday(),
	sys_signal(),
	sys_stat(),
	sys_sync(),
	sys_umount(),
	sys_unlink(),
	sys_wait(),
	sys_write();

int (*sysent[])() = {
	enosys,
	sys_exit,
	sys_execve,
	sys_fork,
	sys_wait,
	sys_read,
	sys_write,
	sys_mkdir,
	sys_mknod,
	sys_open,
	sys_close,
	sys_lseek,
	sys_ioctl,
	sys_chdir,
	sys_link,
	sys_unlink,
	sys_mount,
	sys_umount,
	sys_alarm,
	sys_pause,
	sys_chmod,
	sys_stat,
	sys_fstat,
	sys_gettimeofday,
	sys_settimeofday,
	sys_signal,
	sys_kill,
	sys_dup2,
	sys_pipe,
	sys_getpid,
	sys_getppid,
	sys_nice,
	sys_sync,
	enosys,
	enosys,
	enosys,
};
int nsysent = __SIZEOF(sysent);

