
/* HD64645F */

/* XXX why A2 is high ? */

#define CRTC (PCS3+4)

#define HCHR_TOT       0 /* Nht (n-1) */
#define HCHR_DISPLAY   1 /* Nhd */
#define CHR_LAST       9 /* Nr  */
#define CURSOR_START  10 /* Ncs + blink mode */
#define  CURSOR_ON     0x00
#define  CURSOR_OFF    0x20
#define  CURSOR_BLINK  0x40
#define  CURSOR_BLING  0x60 /* slow blink */
#define CURSOR_LAST   11 /* Nce */
#define START_ADDR    12 /*     LSByte in 13 */
#define CURSOR_ADDR   14 /*     LSByte in 15 */
#define HCHR_VIRTUAL  18 /* Nir */
#define VPIXELS       19 /* Nd  (n-1) LSByte in 20 */
#define START_RASTER  21 /* Nsr */
#define MODE          22
#define MODE_AT        0x01 /* Vcc */
#define MODE_BLE       0x02 /* not connected ? */
#define MODE_WIDE      0x04 /* ground */
#define MODE_G         0x08 /* ground */
#define MODE_ON        0x10 /* ground */

#define ATTR_INVERSE  0x08
#define ATTR_CURSOR   0x10 /* has no effect ? */
#define ATTR_BLINK    0x20
#define ATTR_BLANK    0x40
#define ATTR_BLOCK    0x80

/* XXX original chargen would work (maybe?) like this: */

/* 3 attribute ram lsbits go to chargen rom msbits XXX ordering */

/* 4 normal sets */
#define ATTR_UNDERLINE 0x01
#define ATTR_BOLD      0x02

/* 4 normal sets and 4 quadrant sets for doubling.
 * attribute ram address bits determine quadrant ? */

#define ATTR_8x8       0x04

