
/* 4096 bytes per each font
 * 16 bytes per each character
 * 1 byte per raster line
 * 0x80 left, 0x01 right
 * onebit white, zerobit black
 * room for 8 fonts (attribute bits 0x07)
 *
 * see attribute_NNN in screen.c */

#asm
	entry argh
argh:
font_8x13.inc:
font_8x13bold.inc:
font_9x15.inc:
font_9x15bold.inc:
pixels.inc:

	line0 SET 0x00   ; add nothing to rasterlines
	line1 SET 0x00
	line2 SET 0x00
	line3 SET 0x00
	line4 SET 0x00
	line5 SET 0x00
	line6 SET 0x00
	line7 SET 0x00
	line8 SET 0x00
	line9 SET 0x00
	linea SET 0x00
	lineb SET 0x00
	linec SET 0x00
	lined SET 0x00
	linee SET 0x00   ; no underscore
	linef SET 0x00

	include font_8x13.inc      ; 0 normal
	include font_8x13bold.inc  ; 1 standout

	include font_9x15.inc      ; 2 alternate normal
	include font_9x15bold.inc  ; 3 alternate standout

	linee SET 0xFF   ; underscore

	include font_8x13.inc      ; 4 underscored normal
	include font_8x13bold.inc  ; 5 underscored standout

	include font_9x15.inc      ; 6 underscored alternate normal
	include pixels.inc         ; 7 unity mapping for graphic mode

