
; L8M

PIO_A_DATA = 0x00
PIO_B_DATA = 0x01
PIO_A_CTRL = 0x02
PIO_B_CTRL = 0x03
SIO_A_DATA = 0x10
SIO_B_DATA = 0x11
SIO_A_CSR  = 0x12
SIO_B_CSR  = 0x13
TMR_BRG    = 0x20
TMR_LPF    = 0x21
TMR_MT     = 0x22
TMR_CTRL   = 0x23
DA_TPC     = 0x30 ; TPC = RFC
DA_RFC     = 0x30
AD_RSSI    = 0x40
AD_FPM     = 0x41
AD_BATT    = 0x42
AD_TPC     = 0x43
AD_RPM     = 0x44
AD_TP4     = 0x45
AD_IN7     = 0x46
AD_SQL     = 0x47
OUT_2      = 0x50 ; OUT0 in manual
OUT_0      = 0x60 ; OUT1 in manual
WDOG       = 0x70

O0_VOLUME = 0x07 ; speaker volume
O0_INH    = 0x08 ; speaker off
O0_AUDIOC = 0x10
O0_CCIRC  = 0x20
O0_MTC    = 0x40
O0_MICM   = 0x80

O2_DP     = 0x01 ; aka O1_SD
O2_CLK    = 0x02 ; aka O1_CLK
O1_SRE    = 0x04
O1_STE    = 0x08 ; aka nSTE, strange behaviour
O2_CS1    = 0x10
O2_CS2    = 0x20
O1_TPS    = 0x40
O1_TXOFF  = 0x80

O1_CLK  = O2_CLK
O1_SD   = O2_DP
OUT_1   = OUT_2  ; XXX confusing


PA_CLK2    = 0x01
PA_SLOCKBE = 0x02
PA_WDR     = 0x04
PA_PWR     = 0x08
PA_CCIR    = 0xF0

PB_EEA10  = 0x01
PB_EXIN1  = 0x02
PB_EXIN2  = 0x04
PB_DCU    = 0x08
PB_ROM_SL = 0x10
PB_SMEM   = 0x20
PB_EXAL   = 0x40
PB_PWROFF = 0x80

SA_ONHOOK = 0x08
SA_DA     = 0x20	; DA or I2C /INT
SA_INT    = 0x20

SB_PTT    = 0x20
SB_LOCAL  = 0x10
SB_DMIDLE = 0x08	; 1 means MBUS idle

SB_MON    = 0x80   ; Master ON pulse, a/c coupled

TMR_SEL_BRG  = 0x00
TMR_SEL_LPF  = 0x40
TMR_SEL_MT   = 0x80

